#!/bin/bash
# @f4gbv décembre 2018 - Stats QRM SPOTNIK/RRF
# v2 : choix de la date_début

#ATTENTION  : ce script NE fonctionne QUE sur les serveurs RRF3 et RRF2
# pas sur RRF1 car 2 logs concaténés
# pas sur les links distants
# 88 de isa f4gbv :)


# PARAMETRE MODIFIABLE :
# tpsQRM correspond au nombre de secondes maxi définissant un QRM.
tpsQRM="1";
svxLOG="/tmp/svxlink.log"


# début interface utilisateur :
clear
echo "Edition du journal des QRM (déclenchements intempestifs <=  $tpsQRM secondes )"
echo .
echo .

echo " -----> choisir la date de début des stats :"
echo .

select i in aujourdhui autredate; do
if [ "$i" = "aujourdhui" ]; then
	sDebut=`date --date "$(date +%y%m%d)" "+%d-%m-%Y"`
	echo aujourdhui à 00h00 $sDebut
fi
break
done


# FORMAT de saisie : JJ-MM-AAAA
fr_DATE="^([0-2][0-9]|3[0-1])-(0[0-9]|1[0-2])-[0-9]{4}$"
while ! [[ $sDebut =~ $fr_DATE ]]; do
	echo tapez ENTREE pour date du jour .....
	echo "(Format à respecter : JJ-MM-AAAA) ...(ctrl-c pour Quitter)"
	read sDebut
done
clear
echo voici votre choix : 
echo ---------------------------------------------
echo STATISTIQUES QRM 
echo du    $sDebut 00:00      au $(date +'%c')
echo ---------------------------------------------
echo validez par ENTREE ou Ctrl-C pour annuler.....
read

sJour=`echo $sDebut | cut -d'-' -f1`
sMois=`echo $sDebut | cut -d'-' -f2`
sAnnee=`echo $sDebut | cut -d'-' -f3`

dDebut=`date --date "$sAnnee$sMois$sJour" +'%s'`
 
#Entête de qrm.log :
#------------------


# qrm.log = synthèse des QRMs ; qrms.log=CALLs ; qrmd.log= détails QRM 
> /tmp/qrm.log ;
> /tmp/qrms.log ;
> /tmp/qrmd.log ;
> /tmp/palmares.qrm;
echo ... processus en cours ... ;
tailleSvx=`wc -l<$svxLOG`

ligne0=`sed -n '$p' $svxLOG`;
a=$(echo $ligne0 | cut -d ":" -f1,2,3);
if ! [ -z "$ligne0" ]; then
	
	nStart=0;	nStop=0;
		
	cat  $svxLOG | cut -d: -f1,2,3,5 | grep -E "MsgTalkerStart|MsgTalkerStop" | grep -v "RRF"  > /tmp/tmpqrm;
		
	echo ------------------------------------------ >> /tmp/qrm.log;
	echo STATISTIQUES QRM 							>> /tmp/qrm.log;
	echo du    $sDebut 00:00      au $(date +'%c')  >> /tmp/qrm.log;
	echo ------------------------------------------ >> /tmp/qrm.log;
	cp /tmp/qrm.log /tmp/qrmd.log

	datefin=$(date +'%c');

#CORPS DES STATS QRM :
#---------------------		
	numLigne=0
	echo " 							ctrl-C pour annuler ..."
	cat /tmp/tmpqrm | while read ligneStart; do
			((numLigne++))
			
			echo -ne "$(($tailleSvx-$numLigne))\r" 
			sStart=$(echo $ligneStart | cut -d ":" -f1,2,3);
			dStart=$(date +%s -d "$sStart");
			if [ $dStart -lt $dDebut ] ; then
				dStart=$(date -d "19540325" +'%s')
			fi
			if read ligneStop; then
				((numLigne++))
				sStop=$(echo $ligneStop | cut -d ":" -f1,2,3);
				dStop=$(date +%s -d "$sStop");			
				EcartTemps=$(($dStop-$dStart));
				# si ce n'est pas un QSO alors :
				if [ $EcartTemps -le $tpsQRM ] ; then 
					sCall=${ligneStop:40};		
					echo $sCall en QRM
					echo  $sCall   						>> /tmp/qrms.log;
					echo  $sCall  start : $sStart  stop : $sStop _ EcartTemps:dStop-dStart : EcartTemps: $EcartTemps  : $dStop - $dStart  >> /tmp/qrmd.log
				fi
				
			fi
			
	done
	echo . 											>> /tmp/qrm.log;
	echo Nombre de qrms : 							>> /tmp/qrm.log;
	wc -l</tmp/qrms.log  							>> /tmp/qrm.log;
	echo . 											>> /tmp/qrm.log;
	echo Nombre de déclenchements QRM par Indicatif : >> /tmp/qrm.log;
	sort /tmp/qrms.log | uniq -c 					> /tmp/palmares.qrm;
	sort -b -n -r /tmp/palmares.qrm  				>> /tmp/qrm.log;
	
else
	# à priori pas de QRM pour la date demandée, consulter le log pour confirmer.
	echo pas d infos QRM pour le   $(date  +'%admy') >> /tmp/qrm.log;
fi
echo .