module.exports = function fsm(EE, changeHandler = () => {}, init = {}) {
	const states = Object.create(null)
	
	var NomReflector = ''
	var sReflector = ''
	
	function reset() {
		states.network = ''
		states.nodes = []
		states.transmit = false
		states.receive = false
		states.transmitter = ''
		states.digits = []
	}

	reset()

	Object.assign(states, init)

	function on(event, handler) {
		
		if (typeof EE.addEventListener === 'function') {
			EE.addEventListener(event, evt => {
				handler(JSON.parse(evt.data))
			})			
		} else {
			EE.on(event, handler)
			
		}
	
	}
	var i
	for (i = 0; i < 10; i++)
	{
		if (i === 0)
			{NomReflector = 'ReflectorLogic'}	
		else
			{NomReflector = `ReflectorLogic${i}`}
	
		// à optimiser :
		sReflector = `${NomReflector}.MsgNodeList`
		sReflector = sReflector.toString('utf8')	
		on(sReflector.toString('UTF8'), names => {
			
			states.nodes = names
			changeHandler()
		})
		
		sReflector = `${NomReflector}.MsgNodeLeft`
		sReflector = sReflector.toString('utf8')	
		on(sReflector.toString('UTF8'), ([name]) => {
			const idx = states.nodes.indexOf(name)
			if (idx > -1) {
				states.nodes.splice(idx, 1)
			}
			changeHandler()
		})

		sReflector = `${NomReflector}.MsgNodeJoined`
		sReflector = sReflector.toString('utf8')	
		on(sReflector.toString('UTF8'), ([name]) => {
			states.nodes.unshift(name)
			changeHandler()
		})
		
		sReflector = `${NomReflector}.MsgTalkerStart`
		sReflector = sReflector.toString('utf8')	
		on(sReflector.toString('UTF8'), ([name]) => {
			
			if (!(name.startsWith('RRF'))) {				
				states.transmitter = name
				changeHandler() 
			}
		})
				
	}
	

	on('ReflectorLogic.MsgTalkerStop', ([name]) => { // eslint-disable-line no-unused-vars
		states.transmitter = ''
		changeHandler()
	})

	on('spotnik.network', name => {
		reset()
		states.network = name
		changeHandler()
	})

	on('SimplexLogic.digit', digit => {
		states.digits.push(digit)
		changeHandler()
	})

	on('Rx1.open', () => {
		states.transmit = true
		changeHandler()
	})

	on('Rx1.closed', () => {
		states.transmit = false
		changeHandler()
	})

	on('Tx1.on', () => {
		states.receive = true
		changeHandler()
	})

	on('Tx1.off', () => {
		states.receive = false
		changeHandler()
	})

	return states
}
